#include <Servo.h>

#define MIN_IN_MILLISECONDS 60000

//// tuning parameters of the position of the hand
//int angle[] = {180, 150, 120, 90, 60, 30, 0}; // initial value
int angle[] = {180, 145, 116, 90, 62, 32, 0}; // change this table to tune fine positions
#define RIGHT_END_PWM 560 // tune the position at 60min (right end) typically, 600
#define LEFT_END_PWM 2280 // tune the position at 0min (left end) typically, 2400

Servo myservo;
int prevPos = 0;
int minInc = 0;
int offset = 0;
int min = 0;
int currentMin = -1;

void slowServo(int pos) {
  int i = 0;
  if(prevPos < pos) {
    for(i = prevPos; i <= pos + 2; i++) {
      myservo.write(i);
      delay(10);      
    }
  } else {
    for(i = prevPos; i >= pos - 2; i--) {
      myservo.write(i);
      delay(10);      
    }
  }
  myservo.write(pos);
  prevPos = pos;
}

void moveMin (int min) {
  int j, k, a;

  j = min / 10;
  k = min % 10;
  a = (angle[j] * (10 - k) + angle[j + 1] * k) / 10;
  slowServo(a);
}

void setup() {
  myservo.attach(9, RIGHT_END_PWM, LEFT_END_PWM);  // attaches the servo on pin 9 to the servo object
  myservo.write(0);
  pinMode(14, OUTPUT);
  digitalWrite(14, LOW);
  pinMode(16, INPUT_PULLUP); // button of increment

}

void loop() {
  if(digitalRead(16) == LOW) {
    minInc = (minInc + 1) % 60;
    while(digitalRead(16) == LOW)
      ;
  }
  int newMin = (((millis() - offset) / MIN_IN_MILLISECONDS) + minInc) % 60;
  if (newMin != currentMin) {
    moveMin(newMin);
    currentMin = newMin;
  }
}
